#pragma once

#include "Common.h"
#include "NetworkMessage.h"
#include "protocol/ProtocolDefinitions.h"
#include <cstdio>
#include <cstdint>

namespace Feather
{
    class PacketReader;
    class MinecraftClient;
    class DedicatedServer;
}

namespace Feather::Protocol
{
    class ProtocolContext
    {
    public:
        inline ProtocolState GetState() const
        {
            return m_state;
        }

        inline void SetState(ProtocolState state) 
        {
            Log_Info("Setting state: %d", (int)state);
            m_state = state;
        }
    private:
        ProtocolState m_state = ProtocolState::Handholding;
    };
}
